OST_FTIMER_CB   _OS_FTimers;


void _OS_Ftimer_Add(OST_FTIMER *ftimer)
{
    OST_FTIMER *ftcb;
    _OST_FTIMER temp;
    _OST_FTIMER time;

    ftimer->Flags.bNextEnable = 0;
    ftcb = (OST_FTIMER*)&_OS_FTimers;
    time = ftimer->Timer;
    if (!_OS_FTimers.Flags.bNextEnable) goto ADD;


    while (ftcb->Flags.bNextEnable)
    {
        temp = ((OST_FTIMER *)ftcb->Next)->Timer;
        if (time >= temp)
        {
            ftimer->Flags.bNextEnable = 1;
ADD:
            ftimer->Flags.bTimeout = 0;
            ftimer->Next = ftcb->Next;
            ftcb->Next = ftimer;
            ftcb->Flags.bNextEnable = 1;
            ftimer->Timer = time;

            if (ftimer->Flags.bNextEnable)
            {
                ftimer = ftimer->Next;
                ftimer->Timer -= time;
            }
            return;
        } else {
            time -= temp;
            ftcb = ftcb->Next;
        }
    }
    goto ADD;
}


void _OS_Ftimer_Count (void)
{
    OST_FTIMER *ftcb;

    if (!_OS_FTimers.Flags.bNextEnable) return;
    ftcb = _OS_FTimers.Next;
    if (!++ftcb->Timer)
    {
        ftcb->Flags.bTimeout = 1;
        if (!ftcb->Flags.bNextEnable) _OS_FTimers.Flags.bNextEnable = 0;
        _OS_FTimers.Next = ftcb->Next;
    }
}

void _OS_Ftimer_Count_Asm (void)
{
    _irp = 0;
    _fsr = (_FSR_TYPE) &_OS_FTimers;
    if (_OS_IndfTimerNextEnable)
    {
        _fsr++; // point to next timer
        _fsr = _indf;
        asm("   bcf     __status, 0 ");                 
        /* Now W = fsr */                               
        asm("   incf    __fsr, f    ");
        asm("   incf    __fsr, f    ");
        asm("   incfsz  __indf, f   ");
        asm("   goto    $ + 5       ");
        asm("   incf    __fsr, f    ");
        asm("   incfsz  __indf, f   ");
        asm("   goto    $ + 2       ");
        asm("   bsf     __status, 0 ");
        asm("   movwf   __fsr       ");
        if (_carry) 
        {    
            _OS_IndfTimerTimeout = 1;
            if (!_OS_IndfTimerNextEnable) _OS_FTimers.Flags.bNextEnable = 0;
            _fsr++;
            _OS_FTimers.Next = _indf;
        }
    }
}



